<?php
declare(strict_types = 1);

namespace App\Http\Resources\Outpatient\Record;

use Illuminate\Http\Request;
use Illuminate\Http\Resources\Json\JsonResource;

class RecordListsResource extends JsonResource
{
    /**
     * Transform the resource into an array.
     *
     * @return array<string, mixed>
     */
    public function toArray(Request $request = null): array
    {
        if (empty($this->resource)) {
            return [];
        }

        $lists = [];
        foreach ($this->resource['response'] as $v) {
            $lists[] = [
                'patient_id' => $v['patientId'],
                'patient_name' => $v['patientName'],
                'sex' => $v['sex'],
                'charge_type' => $v['changeType'],
                'visit_date' => $v['visitDate'],
                'receipt_id' => $v['payId'],
                'receipt_no' => $v['rcpiNo'],
                'total_fee' => (float) $v['costs'],
                'self_fee' => (float) $v['expensePay'] ?? 0,
                'reduce_fee' => (float) ($v['jjzf'] ?? (bcsub($v['costs'], $v['expensePay'], 2))),
            ];
        }

        return $lists;
    }
}
